-- disable the K axiom:

{-# OPTIONS --without-K #-}


-- Agda version 2.5.2


module V-model-pt1 where

open import basic-types
open import basic-setoids
open import dependent-setoids
open import subsetoids
open import iterative-sets
open import iterative-sets-pt2
open import iterative-sets-pt3
open import V-model-pt0




-- context extensions


Ext : (Γ : ctx) -> (A : ty Γ) -> ctx
Ext Γ A = sigmaV Γ (ty.type A)

infixl 20 _▷_

_▷_ : (Γ : ctx) -> (A : ty Γ) -> ctx
Γ ▷ A = Ext Γ A


pp-ext : {Γ : ctx} -> (A : ty Γ) -> (u v : || κ (Γ ▷ A) ||) -> (p : < κ (Γ ▷ A) > u ~ v)
     ->  < κ Γ > pj1 u ~ pj1 v
pp-ext {Γ} A (u1 , u2) (v1 , v2) p = <> (prj1 (pairV-inv-1 (>< p))) 

pp : {Γ : ctx} -> (A : ty Γ) -> subst (Γ ▷ A) Γ
pp A = subst.sb (record { op = λ u → pj1 u 
                        ; ext = λ u v p → pp-ext A u v p   })



-- short for pp is downarrow ↓  typed \d

↓ : {Γ : ctx} -> (A : ty Γ) -> subst (Γ ▷ A) Γ
↓ A = pp A

-- the variable term

vv : {Γ : ctx} -> (A : ty Γ) -> raw (Γ ▷ A)
vv {Γ} A = mkraw (pj2-sigmaV  Γ (ty.type A))



asm : {Γ : ctx}
--
      -> (A : ty Γ) 
--   --------------------------------------------------------
      -> Γ ▷ A ==> vv A :: A [[ ↓ A ]]
--
asm {Γ} A =  mk-elt (pj2-sigmaV-prop Γ (ty.type A))



asm-apply : {Γ : ctx}  -> (A : ty Γ)
     -> (x :  || κ Γ ||) ->  (y : || κ (apt A x) ||)
     ->  apr (vv A) (x , y) ≐ apt (A [[ ↓ A ]]) (x , y) ‣ y
asm-apply A x y = (pj2 (apel (asm A) (x , y)))



ext-op : {Δ Γ : ctx} -> (A : ty Γ) 
        ->  (f : subst Δ Γ) -> (a : raw Δ) 
        -> Δ ==> a :: A [[ f ]]
        -> || κ Δ || -> || κ (Γ ▷ A) ||
ext-op A f a p u = (aps f u) , (pj1 (apel p u))
                   


ext-ext : {Δ Γ : ctx} -> (A : ty Γ) 
        ->  (f : subst Δ Γ) -> (a : raw Δ) 
        -> (p : Δ ==> a :: A [[ f ]])
        -> (u  v : || κ Δ ||) 
        -> < κ Δ > u ~ v
        -> < κ (Γ ▷ A) > ext-op A f a p u ~ ext-op A f a p v
ext-ext {Δ} {Γ} A f a p u v q = 
       let  lm1 : < κ Γ > ap (subst.cmap f) u ~ ap (subst.cmap f) v
            lm1 = (extensionality (subst.cmap f) _ _ q)
            lmA : << VV >> (apt A  (ap (subst.cmap f) u)) ~ (apt A  (ap (subst.cmap f) v))
            lmA  = extensionality1 (ty.type A) (ap (subst.cmap f) u) (ap (subst.cmap f) v) lm1
            lmC : (apr a u) ≐ (apt (A [[ f ]]) u) ‣ pj1 (apel p u)
            lmC = pj2 (apel p u)
            lmD : (apr a v) ≐ (apt (A [[ f ]]) v) ‣ pj1 (apel p v)
            lmD = pj2 (apel p v)
            lmE : << VV >> (apr a u) ~ (apr a v)
            lmE = extensionality1 (raw.rawterm a) u v q
            lm2 :  (apt A (ap (subst.cmap f) u)) ‣ pj1 (apel p u) ≐
                   (apt A (ap (subst.cmap f) v)) ‣ pj1 (apel p v)
            lm2 = traV (symV lmC) (traV (>><< lmE) lmD) 

       in <> (pairV-ext (>< lm1) lm2)



ext : {Δ Γ : ctx} -> (A : ty Γ) 
      ->  (f : subst Δ Γ) -> (a : raw Δ) 
      -> Δ ==> a :: A [[ f ]]
      -> subst Δ (Γ ▷ A)
ext {Δ} {Γ} A f a p = subst.sb (record { op = ext-op A f a p 
                                       ; ext = ext-ext A f a p })



ext-irr : {Δ Γ : ctx} -> (A : ty Γ) 
      ->  (f : subst Δ Γ) -> (a : raw Δ) 
      -> (p : Δ ==> a :: A [[ f ]])
      -> (q : Δ ==> a :: A [[ f ]])
      -> < Subst Δ (Γ ▷ A) >  (ext A f a p) ~  (ext A f a q) 
ext-irr {Δ} {Γ} A f a p q  =  
    <> (<> (\ x -> <> (pairV-ext (refV (Γ ‣ aps f x)) (traV (symV (pj2 (apel p x))) (pj2 (apel q x))))))




ext-prop1 : {Δ Γ : ctx} -> (A : ty Γ) 
      -> (f : subst Δ Γ) -> (a : raw Δ) 
      -> (p : Δ ==> a :: A [[ f ]])
      -> < Subst Δ Γ >  ((↓ A) ⌢ (ext A f a p)) ~ f
ext-prop1 {Δ} {Γ} A f a p = <> (<> (λ x → refl (κ Γ) (ap (subst.cmap f) x)))



ext-prop2 : {Δ Γ : ctx} -> (A : ty Γ) 
      ->  (f : subst Δ Γ) -> (a : raw Δ) 
      -> (p : Δ ==> a :: A [[ f ]])
      -> << Raw Δ >>  (vv A) [ ext A f a p ] ~ a
ext-prop2  A f a p = <<>> (<<>> (λ x → 
                              let lm5 : (apt A (ap (subst.cmap f) x)) ‣ (pj1 (apel p x)) ≐ (apr a  x)
                                  lm5 = symV (pj2 (apel p x)) 
                                  main : << VV >> apr (sub (vv A) (ext A f a p)) x ~ (apr a x)
                                  main = <<>> lm5
                               in main))


ext-prop3-lm : {Γ : ctx}-> (A : ty Γ) -> 
        (ctx-maps (Γ ▷ A) (Γ ▷ A) setoid.∼
          subst.cmap (ext A (↓ A) (vv A) (asm A)))
          (subst.cmap (ids {Γ ▷ A}))
ext-prop3-lm {Γ} A (x , y) = 
                  <> (  let    lm2 :  < κ (Γ ▷ A) > (x , y)  ~  (x , y)
                               lm2 = refl (κ (Γ ▷ A)) (x , y)
                               lm1 :  < κ (Γ ▷ A) >
                                        (ap (subst.cmap (pp A)) (x , y)  ,  (pj1 (apel (asm A) (x , y))))
                                       ~  (x , y)
                               lm1 = lm2
                               main : < κ (Γ ▷ A) >
                                       (ext-op A (pp A) (vv A) (asm A)) (x , y)
                                       ~  (x , y)
                               main = lm1
                        in >< main)
      
ext-prop3 : {Γ : ctx}-> (A : ty Γ) ->
            < Subst (Γ ▷ A) (Γ ▷ A) >  (ext A (↓ A) (vv A) (asm A)) ~ ids {Γ ▷ A}
ext-prop3 {Γ} A  = <> (<> (ext-prop3-lm {Γ} A))
      




ext-prop4-lm : {Θ Δ Γ : ctx} -> (A : ty Γ) 
      -> (f : subst Δ Γ) -> (a : raw Δ) 
      -> (p : Δ ==> a :: A [[ f ]])
      -> (h : subst Θ Δ)
      -> Θ ==> a [ h ] :: A [[ f ⌢ h ]]
ext-prop4-lm  {Θ} {Δ} {Γ} A f a p h = 
          let lm1 :  Θ ==> sub a h :: Sub (Sub  A f) h
              lm1  = elt-subst h p 
              lm2a : << Ty Θ >>  (A [[ f ]] [[ h ]])  ~  (A [[ f ⌢ h ]]) 
              lm2a = Sub-comp-prop-sym {Θ} {Δ} {Γ} A f h
              lm2 : Θ ==> Sub (Sub A f) h == Sub A (f ⌢ h)
              lm2 = tyeq-from-eq _ _ lm2a 
              main :  Θ ==> sub a h :: Sub A (f ⌢ h)
              main = elttyeq lm1 lm2
          in main


ext-prop4-lm2 : {Θ Δ Γ : ctx} -> (A : ty Γ) 
      -> (f : subst Δ Γ) -> (a : raw Δ) 
      -> (p : Δ ==> a :: A [[ f ]])
      -> (h : subst Θ Δ)
      -> (q : Θ ==> a [ h ] :: A [[ f ⌢ h ]])
--    --------------------------------------------
      -> < Subst Θ (Γ ▷ A) > ((ext A f a p) ⌢ h) ~ (ext A (f ⌢ h) (a [ h ]) q)
--
ext-prop4-lm2 {Θ} {Δ} {Γ} A f a p h q = <> (<> (λ u → 
              let lm1 :  Γ ‣ ap (subst.cmap f) (ap (subst.cmap h) u) ≐ Γ ‣ ap (subst.cmap (f ⌢ h)) u
                  lm1 = refV _
                  lm2 : << VV >> (apt A  (ap (subst.cmap f) (ap (subst.cmap h) u))) ~
                               (apt A  (ap (subst.cmap (f ⌢ h)) u))
                  lm2 = extensionality1 (ty.type A) (ap (subst.cmap f) (ap (subst.cmap h) u)) 
                                                    (ap (subst.cmap (f ⌢ h)) u)  (<> lm1)
                  p2  : apr a (ap (subst.cmap h) u) ≐
                        (apt (A [[ f ]])  (ap (subst.cmap h) u) ‣ pj1 (apel p (ap (subst.cmap h) u)))
                  p2 = pj2 (apel p (ap (subst.cmap h) u))
                  q2  : apr (a [ h ])  u ≐ (apt (A [[ f ⌢ h ]])  u) ‣ pj1 (apel q u)
                  q2 = pj2 (apel q u)
                  lm3 : (apt A  (ap (subst.cmap f) (ap (subst.cmap h) u))) ‣ pj1 (apel p (ap (subst.cmap h) u))
                          ≐ (apt A (ap (subst.cmap (f ⌢ h)) u)) ‣ pj1 (apel q u)
                  lm3 = traV (symV p2) (traV q2 (refV _))
                  main : < κ (Γ ▷ A) >  ap (subst.cmap (ext A f a p))  (ap (subst.cmap h) u) ~
                                        ap (subst.cmap (ext A (f ⌢ h) (sub a h) q)) u
                  main = <> (pairV-ext lm1 lm3) 
              in main))
   



           
ext-prop4 : {Θ Δ Γ : ctx} -> (A : ty Γ) 
      -> (f : subst Δ Γ) -> (a : raw Δ) 
      -> (p : Δ ==> a :: A [[ f ]])
      -> (h : subst Θ Δ)
--  --------------------------
      -> < Subst Θ (Γ ▷ A) > ((ext A f a p) ⌢ h) ~ (ext A (f ⌢ h) (a [ h ]) (ext-prop4-lm  A f a p h ))
--
ext-prop4 {Θ} {Δ} {Γ} A f a p h = ext-prop4-lm2 A f a p h (ext-prop4-lm  A f a p h )





ext-eq-half-lm : {Γ : ctx}
--
      -> (A  A' : ty Γ) 
      -> (Γ ==> A == A')
-- --------------------------
      -> (Γ ▷ A) ≤ (Γ ▷ A')
ext-eq-half-lm {Γ} A A' p (x , y) =  ( (x , (ap (κ-Fam ±± ape p x) y))) , (pairV-ext (refV (Γ ‣ x)) (e+prop (>><< (ape p x)) y))


ext-eq-half2-lm : {Γ : ctx}
--
      -> (A  A' : ty Γ) 
      -> (Γ ==> A == A')
-- --------------------------
      -> (Γ ▷ A) ≥ (Γ ▷ A')
ext-eq-half2-lm {Γ} A A' p (x , y) =  (x , (ap (κ-Fam ±± ape (tysym p) x) y)) , pairV-ext (refV (Γ ‣ x)) (symV (e+prop (>><< (ape (tysym p) x)) y))

ext-eq : {Γ : ctx}
--
      -> (A  A' : ty Γ) 
      -> (Γ ==> A == A')
-- --------------------------
      -> (Γ ▷ A) ≐ (Γ ▷ A')
ext-eq {Γ} A A' p = pair (ext-eq-half-lm  {Γ} A A' p) (ext-eq-half2-lm {Γ} A A' p) 




ext-eq-lm : {Γ : ctx}
      -> (A  A' : ty Γ) 
      -> (p : Γ ==> A == A')
      -> (x : || κ Γ ||)
      -> (y : || κ (apt A x)||)
      -> < κ (Γ ▷ A') > (ap (κ-trp (ext-eq A A' p) ) (x , y)) ~ (x , (ap (κ-Fam ±± ape p x) y))
ext-eq-lm {Γ} A A' p x y = refl _ _ 




subst-trp-id :  {Γ : ctx} ->  (p : << Ctx >> Γ ~ Γ) 
      -> < Subst Γ Γ > subst-trp p ~ ids {Γ}
subst-trp-id {Γ} p = <> (<> (λ x → κ-trp-id (>><< p) x)) 



subst-trp-irr :  {Γ Δ : ctx} 
      ->  (p q : << Ctx >> Γ ~ Δ) 
      -> < Subst Γ Δ > subst-trp p ~ subst-trp q
subst-trp-irr {Γ} {Δ} p q = <> (<> (λ x → κ-trp-irr (>><< p) (>><< q) x))  


subst-trp-fun :  {Γ Δ  Θ : ctx} 
    ->  (p : << Ctx >> Γ ~ Δ)   ->  (q : << Ctx >> Δ ~ Θ) 
    ->  (r : << Ctx >> Γ ~ Θ)
    -> < Subst Γ Θ > ((subst-trp q) ⌢ (subst-trp p)) ~ subst-trp r
subst-trp-fun {Γ} {Δ} {Θ} p q r = <> (<> (λ x → sym (κ-trp-fn (>><< q) (>><< p) (>><< r) x)))



-- substitution of an element in the last argument and a short form

ext-el :  
       {Γ : ctx} 
    -> (A : ty Γ)   
    -> (a : raw Γ)
    -> (Γ ==> a :: A)
    -> subst Γ (Γ ▷ A)
ext-el {Γ} A a p = ext A (ids {Γ}) a p




els  :  
       {Γ : ctx} 
    -> {A : ty Γ}   
    -> {a : raw Γ}
    -> (Γ ==> a :: A)
    -> subst Γ (Γ ▷ A)
els {Γ} {A} {a} p = ext-el {Γ} A a p

els-irr :   {Γ : ctx} 
    -> {A : ty Γ}   
    -> {a : raw Γ}
    -> (p : Γ ==> a :: A)
    -> (q : Γ ==> a :: A)
    -> < Subst Γ (Γ ▷ A) > els p ~ els q
els-irr {Γ} {A} {a} p q = ext-irr A (ids {Γ}) a p q



els-cong :   {Γ : ctx} 
    -> {A : ty Γ}   
    -> {a a' : raw Γ}
    -> (p : Γ ==> a :: A)
    -> (q : Γ ==> a' :: A)
    -> (Γ ==> a == a' :: A)
    -> < Subst Γ (Γ ▷ A) > els p ~ els q
els-cong {Γ} {A} {a} {a'} p q r =
 <> (<> 
   (\ x -> 
 
     let lm1 : apr a x ≐ apt A x ‣ pj1 (apel p x)
         lm1 = pj2 (apel p x)
         lm2 : apr a' x ≐ apt A x ‣ pj1 (apel q x)         
         lm2 = pj2 (apel q x)
         lm : (ty.type A • aps (ids {Γ}) x) ‣ pj1 (apel p x) ≐ (ty.type A • aps (ids {Γ}) x) ‣ pj1 (apel q x)
         lm = traV (symV lm1) (traV (prj1 r x) lm2)
     in <> (pairV-ext (refV (Γ ‣ aps (ids {Γ}) x)) lm)
  ))



qq :  {Δ Γ : ctx} 
--
     -> (A : ty Γ)    -> (h : subst Δ Γ) 
--  --------------------------------------
     -> subst (Δ ▷ (A [[ h ]])) (Γ ▷ A)
qq A h = ext  A 
                         (h ⌢ (↓ (A [[ h ]]))) 
                         (vv (A [[ h ]])) (elttyeq  
                                     (asm (A [[ h ]]))
                                     (tyeq-from-eq  ((A [[ h ]]) [[ ↓ (A [[ h ]]) ]]) (A [[ h ⌢ ↓ (A [[ h ]]) ]]) 
                                           (Sub-comp-prop-sym A h (↓ (A [[ h ]])))
                                     ))


-- the q-operation in terms of extension


-- short for qq is ↑ entered  \u

↑ :  {Δ Γ : ctx}  -> (A : ty Γ)    -> (h : subst Δ Γ) 
     -> subst (Δ ▷ (A [[ h ]])) (Γ ▷ A)
↑ A h = qq A h




qq-eq :  {Δ Γ : ctx} 
       -> (A : ty Γ)    -> (h : subst Δ Γ) 
       -> (x : # Δ)
       -> (y : # (apt (A [[ h ]]) x))
       -> < κ (Γ ▷ A) > aps (↑ A h) (x , y) ~ (aps h x , y) 
qq-eq {Δ} {Γ} A h x y = 

    let lm2 = elttyeq-lm (asm (A [[ h ]]))
                         (tyeq-from-eq 
                           ((A [[ h ]]) [[ ↓ (A [[ h ]]) ]])
                           (A [[ h ⌢ ↓ (A [[ h ]]) ]])
                           (Sub-comp-prop-sym A h (↓ (A [[ h ]]))))
                         (x , y)
              
        lm : (apt A (aps (h ⌢ ↓ (A [[ h ]])) (x , y))) ‣
              pj1
             (apel (elttyeq 
                      (asm (A [[ h ]]))
             (tyeq-from-eq 
               ((A [[ h ]]) [[ ↓ (A [[ h ]]) ]])
               (A [[ h ⌢ ↓ (A [[ h ]]) ]])
               (Sub-comp-prop-sym A h (↓ (A [[ h ]])))
               ))
               (x , y))
               ≐ (apt A (aps h x)) ‣ y
        lm = symV lm2
    in <> (pairV-ext (refV _) lm)



qq-ext-el-lm :  {Γ : ctx} 
    -> (A : ty Γ)
    -> < Subst (Γ ▷ A) (Γ ▷ A) >  ((↑ A (↓ A))  ⌢  (els (asm A)))
                                         ~ (ids {Γ ▷ A})
qq-ext-el-lm {Γ} A  = 
  <> (<> (λ z → 
   let lm2 = elttyeq-lm
                (asm {Γ ▷ A} (A [[ ↓ A ]]))
                (tyeq-from-eq 
                 ((A [[ ↓ A ]]) [[ ↓ (A [[ ↓ A ]]) ]])
                    (A [[ ↓ A ⌢ ↓ (A [[ ↓ A ]]) ]])
                 (Sub-comp-prop-sym A (↓ A) (↓ (A [[ ↓ A ]]))))
                (aps (els (asm A)) 
                  z)
 
       lm : (apt A
             (aps (pp A ⌢ ↓ (A [[ ↓ A ]]))
             (aps (els (asm A))
              z)))
            ‣
            pj1
            (apel (elttyeq 
                  (asm (A [[ ↓ A ]]))
                  (tyeq-from-eq 
                      ((A [[ ↓ A ]]) [[ ↓ (A [[ ↓ A ]]) ]])
                      (A [[ ↓ A ⌢ ↓ (A [[ ↓ A ]]) ]])
                     (Sub-comp-prop-sym A ( ↓ A) ( ↓ (A [[ ↓ A ]])))))
                  (aps (els (asm A))
              z))
            ≐ (apt A (pj1 z)) ‣ (pj2 z)
       lm = traV (symV lm2) (refV _)  

   in <> (pairV-ext (refV (Γ ‣ (pj1 z))) lm )))
