-- disable the K axiom:

{-# OPTIONS --without-K #-}


-- Agda version 2.5.2


module V-model-pt9 where

open import basic-types
open import basic-setoids       -- 525 lines
open import dependent-setoids   -- 559 lines
open import subsetoids          -- 341 lines
open import iterative-sets      -- 869 lines
open import iterative-sets-pt2  -- 326 lines
open import iterative-sets-pt3  -- 439 lines
open import V-model-pt0
open import V-model-pt1         -- 776 lines
open import V-model-pt2         -- 511 lines
open import V-model-pt3         -- 522 lines
open import V-model-pt4         -- 283 lines
open import V-model-pt5         -- 225 lines
open import V-model-pt6         -- 842 lines
open import V-model-pt7         --  66 lines
open import V-model-pt8         -- 134 lines
                     -- this file  441 lines
                     -- total     6859 lines

Σ-f :  {Γ : ctx} 
--
       -> (A : ty Γ)   -> (B : ty (Γ ▷ A))
--     ---------------------------------------
       -> ty Γ
-- 
Σ-f A B = ty.tyy (comp01 sigmaVV (mk-Par A  B))


Σ-f-exp1 :  {Γ : ctx} 
       -> (A : ty Γ)   -> (B : ty (Γ ▷ A))
       -> (u : || κ Γ ||)
       ->  (apt (Σ-f A B)  u) ≐ sigmaV (apt A u) (mk-Par-op-Fx A B u)
Σ-f-exp1 A B u = refV _

-- sigmaV : (a : V) -> (g :  setoidmap1 (κ a) VV) -> V
-- sigmaV a g =  sup (Σ (# a) (\y -> # (g • y))) 
--                     (\u -> < a ‣ (pj1 u) , (g • (pj1 u)) ‣ (pj2 u) >)

-- Move to iterative-sets-pt2.agda:

sigmaV-iV : (a : V) -> (g :  setoidmap1 (κ a) VV) -> Set
sigmaV-iV a g = Σ (# a) (\y -> # (g • y))

sigmaV-bV : (a : V) -> (g :  setoidmap1 (κ a) VV) ->  sigmaV-iV a g -> V
sigmaV-bV a g u =  < a ‣ (pj1 u) , (g • (pj1 u)) ‣ (pj2 u) >

Σ-f-exp2 :  {Γ : ctx} 
       -> (A : ty Γ)   -> (B : ty (Γ ▷ A))
       -> (u : || κ Γ ||)
       ->  (apt (Σ-f A B)  u) ≐ sup (sigmaV-iV (apt A u) (mk-Par-op-Fx A B u))
                                    (sigmaV-bV (apt A u) (mk-Par-op-Fx A B u))  
Σ-f-exp2 A B u = refV _

Σ-f-exp3 :  {Γ : ctx} 
       -> (A : ty Γ)   -> (B : ty (Γ ▷ A))
       -> (x : || κ Γ ||)
       -> (u : # (apt (Σ-f {Γ} A B)  x))
       -> (apt (Σ-f {Γ} A B)  x) ‣ u ≐  < (apt A x) ‣ (pj1 u) , (apt B  (x , (pj1  u))) ‣ (pj2 u) >
Σ-f-exp3  A B x u = refV _



Σ-f-cong : {Γ : ctx}
--
      -> (A  A' : ty Γ) 
      -> (p : Γ ==> A == A')
      -> (B : ty (Γ ▷ A))
      -> (B' : ty (Γ ▷ A'))
      -> (Γ ▷ A ==> B == (B' [[  subst-trp (ext-eq' A A' p) ]]))
-- ---------------------
      -> Γ ==> Σ-f A B == Σ-f A' B'
Σ-f-cong {Γ} A A' p B B' q  = mk-eqty (λ x → let lm = mk-Par-cong  {Γ} A A' p B B' q x
                                              in extensionality11 sigmaVV (ap1 (mk-Par A B) x) (ap1 (mk-Par  A' B') x) lm)

pr-op : {Γ : ctx} 
--
      -> (a  : raw Γ) 
      -> (b : raw Γ) 
      -> (|| κ Γ || -> V)
pr-op {Γ} a b x =  < apr a x , apr b x > 


pr : {Γ : ctx} 
--
      -> (a  : raw Γ) 
      -> (b : raw Γ) 
      -> raw Γ
pr {Γ} a b = mkraw (record { op = pr-op {Γ} a b 
                           ; ext = λ x y p → <<>> (pairV-ext (>><< (extensionality1 (raw.rawterm a) x y p)) 
                                                       (>><< (extensionality1 (raw.rawterm b) x y p)))
                           })



pr-cong : {Γ : ctx} 
--
      -> (a a'  : raw Γ) 
      -> (b b' : raw Γ) 
      -> << Raw Γ >> a ~ a'
      -> << Raw Γ >> b ~ b'
      -> << Raw Γ >> pr a b ~ pr a' b'
pr-cong a a' b b' p q  = Raw-lm2 (\x -> pairV-ext (Raw-lm p x) (Raw-lm q x))


Σ-i : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (a  : raw Γ) 
      -> (p : Γ ==> a :: A)
      -> (b : raw Γ)
      -> (Γ ==> b :: (B [[ els p ]]))
      -> Γ ==> pr a b :: Σ-f A B
Σ-i {Γ} A B a p b q = mk-elt (λ x → ((pj1 (apel p x)) , (pj1 (apel q x))) , pairV-ext (pj2 (apel p x)) (pj2 (apel q x)))

-- see iterative-sets-pt2.agd

pr1-op : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (Γ ==> c :: Σ-f A B)
      -> (|| κ Γ || -> V)
pr1-op {Γ} A B c p x =  apt A x  ‣ pj1 (pj1 (apel p x))
  
-- pj1-sigmaV-op : (a : V) -> (g :  setoidmap1 (κ a) VV) ->
--             ||  κ (sigmaV a g) || -> V
-- pj1-sigmaV-op a g u = a ‣ (pj1 u)

-- pj1-sigmaV : (a : V) -> (g :  setoidmap1 (κ a) VV) ->
--             setoidmap1 (κ (sigmaV a g)) VV

pr1-ext  : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (p : Γ ==> c :: Σ-f A B)
      -> (x y : || κ Γ ||)
      -> (q : < κ Γ > x ~ y)
      -> << VV >> pr1-op A B c p x ~ pr1-op A B c p y
pr1-ext {Γ} A B c p x y q =  -- extensionality1 ((raw.rawterm c)) x y q
       let lm2 = pj2 (apel p x)
           lm4 = pj2 (apel p y)
           eq : apr c x ≐ apr c y
           eq = >><< (extensionality1 (raw.rawterm c) x y q)
           eq2 : apt (Σ-f A B) x ‣ pj1 (apel p x) ≐ apt (Σ-f A B) y ‣ pj1 (apel p y)
           eq2 = traV (symV lm2) (traV eq lm4)
           eq3 : < (apt A x) ‣ (pj1 (pj1 (apel p x))) , (apt B  (x , (pj1  (pj1 (apel p x))))) ‣ (pj2 (pj1 (apel p x))) >
               ≐ < (apt A y) ‣ (pj1 (pj1 (apel p y))) , (apt B  (y , (pj1  (pj1 (apel p y))))) ‣ (pj2 (pj1 (apel p y))) >
           eq3 = traV (symV (Σ-f-exp3 A B x (pj1 (apel p x)))) (traV eq2 (Σ-f-exp3 A B y (pj1 (apel p y)))) 


           main : apt A x  ‣ pj1 (pj1 (apel p x)) ≐  apt A y  ‣ pj1 (pj1 (apel p y))
           main = prj1 (pairV-inv-1 eq3)
       in <<>> main


pr1 : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (Γ ==> c :: Σ-f A B)
      -> raw Γ
pr1 {Γ} A B c p = mkraw (record { op = pr1-op {Γ} A B c p 
                                ; ext = pr1-ext {Γ} A B c p })

pr1-cong : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c c'  : raw Γ)
      -> (p : Γ ==> c :: Σ-f A B)
      -> (p' : Γ ==> c' :: Σ-f A B)
      -> << Raw Γ >>  c ~ c'
      -> << Raw Γ >> pr1 {Γ} A B c p ~  pr1 {Γ} A B c' p'
pr1-cong {Γ} A B c c' p p' q = Raw-lm2 {Γ}
   (\ x ->
   let lm1 : apt (Σ-f A B) x ‣ pj1 (apel p x) ≐
               < apt A x ‣ pj1 (pj1 (apel p x)) ,  apt B (x , pj1 (pj1 (apel p x))) ‣ pj2 (pj1 (apel p x)) >
       lm1 = Σ-f-exp3 A B x (pj1 (apel p x))
       lm2 = pj2 (apel p x)
       lm3 : apt (Σ-f A B) x ‣ pj1 (apel p' x) ≐
               < apt A x ‣ pj1 (pj1 (apel p' x)) ,  apt B (x , pj1 (pj1 (apel p' x))) ‣ pj2 (pj1 (apel p' x)) >
       lm3 = Σ-f-exp3 A B x (pj1 (apel p' x))
       lm4 = pj2 (apel p' x)
       lm5 : apr c x ≐ apr c' x
       lm5 = (Raw-lm q) x
       lm6 :  < apt A x ‣ pj1 (pj1 (apel p x)) ,  apt B (x , pj1 (pj1 (apel p x))) ‣ pj2 (pj1 (apel p x)) >
             ≐ < apt A x ‣ pj1 (pj1 (apel p' x)) ,  apt B (x , pj1 (pj1 (apel p' x))) ‣ pj2 (pj1 (apel p' x)) >
       lm6 = traV (symV lm1) (traV (traV (symV  lm2) (traV lm5 lm4)) lm3)
       main :   (apr (pr1 A B c p)  x) ≐ (apr (pr1 A B c' p')  x)
             
       main =  prj1 (pairV-inv-1 lm6)
   in main)




Σ-e-1 : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (p : Γ ==> c :: Σ-f A B)
      -> Γ ==> pr1 A B c p :: A
 
Σ-e-1 {Γ} A B c p = mk-elt (λ x → (pj1 (pj1 (apel p x))) , (refV _))




pr2-op : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (Γ ==> c :: Σ-f A B)
      -> (|| κ Γ || -> V)
pr2-op {Γ} A B c p x = (apt B (x , pj1 (pj1 (apel p x)))) ‣ pj2 (pj1 (apel p x)) 



pr2-ext  : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (p : Γ ==> c :: Σ-f A B)
      -> (x y : || κ Γ ||)
      -> (q : < κ Γ > x ~ y)
      -> << VV >> pr2-op A B c p x ~ pr2-op A B c p y
pr2-ext {Γ} A B c p x y q = 
   let     lm2 = pj2 (apel p x)
           lm4 = pj2 (apel p y)
           eq : apr c x ≐ apr c y
           eq = >><< (extensionality1 (raw.rawterm c) x y q)
           eq2 : apt (Σ-f A B) x ‣ pj1 (apel p x) ≐ apt (Σ-f A B) y ‣ pj1 (apel p y)
           eq2 = traV (symV lm2) (traV eq lm4)
           eq3 : < (apt A x) ‣ (pj1 (pj1 (apel p x))) , (apt B  (x , (pj1  (pj1 (apel p x))))) ‣ (pj2 (pj1 (apel p x))) >
               ≐ < (apt A y) ‣ (pj1 (pj1 (apel p y))) , (apt B  (y , (pj1  (pj1 (apel p y))))) ‣ (pj2 (pj1 (apel p y))) >
           eq3 = traV (symV (Σ-f-exp3 A B x (pj1 (apel p x)))) (traV eq2 (Σ-f-exp3 A B y (pj1 (apel p y)))) 


           main : (apt B (x , pj1 (pj1 (apel p x)))) ‣ pj2 (pj1 (apel p x)) ≐ (apt B (y , pj1 (pj1 (apel p y)))) ‣ pj2 (pj1 (apel p y)) 
           main = prj2 (pairV-inv-1 eq3)
   in <<>> main
  


pr2 : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (Γ ==> c :: Σ-f A B)
      -> raw Γ
pr2 {Γ} A B c p = mkraw (record { op = pr2-op {Γ} A B c p 
                                ; ext = pr2-ext {Γ} A B c p })



Σ-e-2-lm : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (p : Γ ==> c :: Σ-f A B)
      -> (q : Γ ==> pr1 A B c p :: A)
      -> (x : || κ Γ ||)
      -> apr (pr2 A B c p) x ∈ apt (B [[ els q ]]) x
Σ-e-2-lm {Γ} A B c p q x = 
   let lm : apt (Σ-f A B) x ‣ pj1 (apel p x) ≐
               < apt A x ‣ pj1 (pj1 (apel p x)) ,  apt B (x , pj1 (pj1 (apel p x))) ‣ pj2 (pj1 (apel p x)) >
       lm = Σ-f-exp3 A B x (pj1 (apel p x))
       lm2 : < apt A x ‣ pj1 (pj1 (apel p x)) ,  apt B (x , pj1 (pj1 (apel p x))) ‣ pj2 (pj1 (apel p x)) > 
             ∈ sigmaV (apt A x) (mk-Par-op-Fx A B x)
       lm2 = memV-right-ext _ _ _ (pj1 (apel p x) , (symV lm)) (symV (Σ-f-exp1 {Γ} A B x))
       lm3 = sigmaV-lm (apt A x) (mk-Par-op-Fx A B x) _ _ lm2
       q2 = pj1 lm3
       pq1 = pj1 (apel q x)
       pq2 = pj2 (apel q x)
       
       lm4 :  apt B (x , pj1 (pj1 (apel p x))) ‣ pj2 (pj1 (apel p x)) ∈
                      mk-Par-op-Fx A B x • pj1 q2
       lm4 = pj2 lm3
       eq1 : Γ ‣ x ≐ Γ ‣ aps (ids {Γ}) x
       eq1 = refV _
       eq3 :  (ty.type A • x)  ≐  (ty.type A • aps  (ids {Γ}) x)
       eq3 = refV _
       eq2 :  (ty.type A • x) ‣ pj1 (pj1 (apel p x)) ≐  (ty.type A • aps  (ids {Γ}) x) ‣ pj1 (apel q x)
       eq2 = pq2 

       eq :  < κ (Γ ▷ A) > x , pj1 (pj1 (apel p x)) ~  ap (subst.cmap (els q)) x
       eq = <> (pairV-ext eq1 eq2)
       lm5 :  mk-Par-op-Fx A B x • pj1 q2 ≐ apt (B [[ els q ]]) x
       lm5 = >><< (extensionality1 (ty.type B) ( x , pj1 (pj1 (apel p x))) ( ap (subst.cmap (els q)) x) eq)
       main : apr (pr2 A B c p) x ∈ apt (B [[ els q ]]) x
       main = memV-right-ext _ _ _ lm4 lm5
   in main
      



pr2-cong : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c c'  : raw Γ)
      -> (p : Γ ==> c :: Σ-f A B)
      -> (p' : Γ ==> c' :: Σ-f A B)
      -> << Raw Γ >>  c ~ c'
      -> << Raw Γ >> pr2 {Γ} A B c p ~  pr2 {Γ} A B c' p'
pr2-cong {Γ} A B c c' p p' q = Raw-lm2 {Γ}
   (\x -> 
   let lm1 : apt (Σ-f A B) x ‣ pj1 (apel p x) ≐
               < apt A x ‣ pj1 (pj1 (apel p x)) ,  apt B (x , pj1 (pj1 (apel p x))) ‣ pj2 (pj1 (apel p x)) >
       lm1 = Σ-f-exp3 A B x (pj1 (apel p x))
       lm2 = pj2 (apel p x)
       lm3 : apt (Σ-f A B) x ‣ pj1 (apel p' x) ≐
               < apt A x ‣ pj1 (pj1 (apel p' x)) ,  apt B (x , pj1 (pj1 (apel p' x))) ‣ pj2 (pj1 (apel p' x)) >
       lm3 = Σ-f-exp3 A B x (pj1 (apel p' x))
       lm4 = pj2 (apel p' x)
       lm5 : apr c x ≐ apr c' x
       lm5 = (Raw-lm q) x
       lm6 :  < apt A x ‣ pj1 (pj1 (apel p x)) ,  apt B (x , pj1 (pj1 (apel p x))) ‣ pj2 (pj1 (apel p x)) >
             ≐ < apt A x ‣ pj1 (pj1 (apel p' x)) ,  apt B (x , pj1 (pj1 (apel p' x))) ‣ pj2 (pj1 (apel p' x)) >
       lm6 = traV (symV lm1) (traV (traV (symV  lm2) (traV lm5 lm4)) lm3)
       main :  (apr (pr2 A B c p)  x) ≐ (apr (pr2 A B c' p')  x)
             
       main =  prj2 (pairV-inv-1 lm6)
   in main)


Σ-e-2 : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (p : Γ ==> c :: Σ-f A B)
      -> (q : Γ ==> pr1 A B c p :: A)
      -> Γ ==> pr2 A B c p :: B [[ els q ]]
Σ-e-2 {Γ} A B c p q = mk-elt (Σ-e-2-lm {Γ} A B c p q)




Σ-c-1-raw : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (a  : raw Γ) 
      -> (p : Γ ==> a :: A)
      -> (b : raw Γ)
      -> (Γ ==> b :: (B [[ els p ]]))
      -> (q : Γ ==> pr a b :: Σ-f A B)
      -> (x : || κ Γ ||)
      -> apr (pr1 A B (pr a b) q) x ≐ apr a x
Σ-c-1-raw {Γ} A B a p b r q x = 
    let   lm : apt (Σ-f A B) x ‣ pj1 (apel q x) ≐
                 < apt A x ‣ pj1 (pj1 (apel q x)) ,  apt B (x , pj1 (pj1 (apel q x))) ‣ pj2 (pj1 (apel q x)) >
          lm = Σ-f-exp3 A B x (pj1 (apel q x))
          lm2 = pj2 (apel q x)
          lm3 :  apr (pr a b) x ≐
                 < apt A x ‣ pj1 (pj1 (apel q x)) ,  apt B (x , pj1 (pj1 (apel q x))) ‣ pj2 (pj1 (apel q x)) >
          lm3 = traV lm2 lm
          lm4 = pairV-inv-1 lm3
          main :  apr (pr1 A B (pr a b) q) x ≐ apr a x
          main = symV (prj1 lm4)
    in main



Σ-c-1 : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (a  : raw Γ) 
      -> (p : Γ ==> a :: A)
      -> (b : raw Γ)
      -> (Γ ==> b :: (B [[ els p ]]))
      -> (q : Γ ==> pr a b :: Σ-f A B)
      -> Γ ==> pr1 A B (pr a b) q == a :: A
Σ-c-1 {Γ} A B a p b r q =  pair (Σ-c-1-raw {Γ} A B a p b r q) (pair (Σ-e-1 {Γ} A B (pr a b) q) p)

 

Σ-c-2-raw : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (a  : raw Γ) 
      -> (p : Γ ==> a :: A)
      -> (b : raw Γ)
      -> (Γ ==> b :: (B [[ els p ]]))
      -> (q : Γ ==> pr a b :: Σ-f A B)
      -> (x : || κ Γ ||)
      -> apr (pr2 A B (pr a b) q) x ≐ apr b x
Σ-c-2-raw {Γ} A B a p b r q x  =   
  let     lm : apt (Σ-f A B) x ‣ pj1 (apel q x) ≐
                 < apt A x ‣ pj1 (pj1 (apel q x)) ,  apt B (x , pj1 (pj1 (apel q x))) ‣ pj2 (pj1 (apel q x)) >
          lm = Σ-f-exp3 A B x (pj1 (apel q x))
          lm2 = pj2 (apel q x)
          lm3 :  apr (pr a b) x ≐
                 < apt A x ‣ pj1 (pj1 (apel q x)) ,  apt B (x , pj1 (pj1 (apel q x))) ‣ pj2 (pj1 (apel q x)) >
          lm3 = traV lm2 lm
          lm4 = pairV-inv-1 lm3
          main :  apr (pr2 A B (pr a b) q) x ≐ apr b x
          main = symV (prj2 lm4)
    in main
    

  

Σ-c-2 : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (a  : raw Γ) 
      -> (p : Γ ==> a :: A)
      -> (b : raw Γ)
      -> (Γ ==> b :: (B [[ els p ]]))
      -> (q : Γ ==> pr a b :: Σ-f A B)
      ->  Γ ==> pr2 A B (pr a b) q == b  :: (B [[ els p ]])
Σ-c-2 {Γ} A B a p b r q = pair (Σ-c-2-raw {Γ} A B a p b r q) 
                               (pair (subj-red {Γ} {B [[ els p ]]}
                                               b (pr2 A B (pr a b) q) r
                                               (sym' (Raw-lm2 (Σ-c-2-raw {Γ} A B a p b r q)))) r)





Σ-c-eta-raw : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (p : Γ ==> c :: Σ-f A B)
      -> (x : || κ Γ ||)
      -> apr c x ≐ apr (pr (pr1 A B c p) (pr2 A B c p)) x
Σ-c-eta-raw {Γ} A B c p x = 
   let lm : apt (Σ-f A B) x ‣ pj1 (apel p x) ≐
               < apt A x ‣ pj1 (pj1 (apel p x)) ,  apt B (x , pj1 (pj1 (apel p x))) ‣ pj2 (pj1 (apel p x)) >
       lm = Σ-f-exp3 A B x (pj1 (apel p x))
       lm2 = pj2 (apel p x)
       main : apr c x ≐ apr (pr (pr1 A B c p) (pr2 A B c p)) x
       main = traV lm2 (traV lm (pairV-ext (refV _) (refV _)))
   in main




Σ-c-eta : {Γ : ctx}
      -> (A  : ty Γ) 
      -> (B : ty (Γ ▷ A))
      -> (c  : raw Γ)
      -> (p : Γ ==> c :: Σ-f A B)
      ->  Γ ==> c == pr (pr1 A B c p) (pr2 A B c p) :: Σ-f A B
Σ-c-eta {Γ} A B c p = pair (Σ-c-eta-raw {Γ} A B c p) 
                           (pair p 
                                (Σ-i {Γ} A B (pr1 A B c p) (Σ-e-1 {Γ} A B c p) 
                                             (pr2 A B c p) (Σ-e-2 {Γ} A B c p (Σ-e-1 {Γ} A B c p))))

